rte_pmd_ixgbe.h(3)

NAME
rte_pmd_ixgbe.h

SYNOPSIS

#include <rte_compat.h>
#include <rte_ethdev.h>
#include <rte_ether.h>

  Data Structures

struct rte_pmd_ixgbe_mb_event_param

  Enumerations

enum rte_pmd_ixgbe_mb_event_rsp { RTE_PMD_IXGBE_MB_EVENT_NOOP_ACK, RTE_PMD_IXGBE_MB_EVENT_NOOP_NACK, RTE_PMD_IXGBE_MB_EVENT_PROCEED, RTE_PMD_IXGBE_MB_EVENT_MAX }

  Functions

int rte_pmd_ixgbe_ping_vf (uint16_t port, uint16_t vf)
int rte_pmd_ixgbe_set_vf_mac_addr (uint16_t port, uint16_t vf, struct rte_ether_addr *mac_addr)
int rte_pmd_ixgbe_set_vf_vlan_anti_spoof (uint16_t port, uint16_t vf, uint8_t on)
int rte_pmd_ixgbe_set_vf_mac_anti_spoof (uint16_t port, uint16_t vf, uint8_t on)
int rte_pmd_ixgbe_set_vf_vlan_insert (uint16_t port, uint16_t vf, uint16_t vlan_id)
int rte_pmd_ixgbe_set_tx_loopback (uint16_t port, uint8_t on)
int rte_pmd_ixgbe_set_all_queues_drop_en (uint16_t port, uint8_t on)
int rte_pmd_ixgbe_set_vf_split_drop_en (uint16_t port, uint16_t vf, uint8_t on)
int rte_pmd_ixgbe_set_vf_vlan_stripq (uint16_t port, uint16_t vf, uint8_t on)
int rte_pmd_ixgbe_macsec_enable (uint16_t port, uint8_t en, uint8_t rp)
int rte_pmd_ixgbe_macsec_disable (uint16_t port)
int rte_pmd_ixgbe_macsec_config_txsc (uint16_t port, uint8_t *mac)
int rte_pmd_ixgbe_macsec_config_rxsc (uint16_t port, uint8_t *mac, uint16_t pi)
int rte_pmd_ixgbe_macsec_select_txsa (uint16_t port, uint8_t idx, uint8_t an, uint32_t pn, uint8_t *key)
int rte_pmd_ixgbe_macsec_select_rxsa (uint16_t port, uint8_t idx, uint8_t an, uint32_t pn, uint8_t *key)
int rte_pmd_ixgbe_set_vf_rxmode (uint16_t port, uint16_t vf, uint16_t rx_mask, uint8_t on)
int rte_pmd_ixgbe_set_vf_rx (uint16_t port, uint16_t vf, uint8_t on)
int rte_pmd_ixgbe_set_vf_tx (uint16_t port, uint16_t vf, uint8_t on)
int rte_pmd_ixgbe_set_vf_vlan_filter (uint16_t port, uint16_t vlan, uint64_t vf_mask, uint8_t vlan_on)
int rte_pmd_ixgbe_set_vf_rate_limit (uint16_t port, uint16_t vf, uint32_t tx_rate, uint64_t q_msk)
int rte_pmd_ixgbe_set_tc_bw_alloc (uint16_t port, uint8_t tc_num, uint8_t *bw_weight)
int rte_pmd_ixgbe_bypass_init (uint16_t port)
int rte_pmd_ixgbe_bypass_state_show (uint16_t port, uint32_t *state)
int rte_pmd_ixgbe_bypass_state_set (uint16_t port, uint32_t *new_state)
int rte_pmd_ixgbe_bypass_event_show (uint16_t port, uint32_t event, uint32_t *state)
int rte_pmd_ixgbe_bypass_event_store (uint16_t port, uint32_t event, uint32_t state)
int rte_pmd_ixgbe_bypass_wd_timeout_store (uint16_t port, uint32_t timeout)
int rte_pmd_ixgbe_bypass_ver_show (uint16_t port, uint32_t *ver)
int rte_pmd_ixgbe_bypass_wd_timeout_show (uint16_t port, uint32_t *wd_timeout)
int rte_pmd_ixgbe_bypass_wd_reset (uint16_t port)
int rte_pmd_ixgbe_mdio_lock (uint16_t port)
int rte_pmd_ixgbe_mdio_unlock (uint16_t port)
int rte_pmd_ixgbe_mdio_unlocked_read (uint16_t port, uint32_t reg_addr, uint32_t dev_type, uint16_t *phy_data)
int rte_pmd_ixgbe_mdio_unlocked_write (uint16_t port, uint32_t reg_addr, uint32_t dev_type, uint16_t phy_data)
int rte_pmd_ixgbe_upd_fctrl_sbp (uint16_t port, int enable)
__rte_experimental int rte_pmd_ixgbe_get_fdir_info (uint16_t port, struct rte_eth_fdir_info *fdir_info)
__rte_experimental int rte_pmd_ixgbe_get_fdir_stats (uint16_t port, struct rte_eth_fdir_stats *fdir_stats)

Detailed Description

ixgbe PMD specific functions.

Definition in file rte_pmd_ixgbe.h.

Enumeration Type Documentation

  enum rte_pmd_ixgbe_mb_event_rsp
Response sent back to ixgbe driver from user app after callback

Enumerator

RTE_PMD_IXGBE_MB_EVENT_NOOP_ACK
    skip mbox request and ACK

RTE_PMD_IXGBE_MB_EVENT_NOOP_NACK
    skip mbox request and NACK

RTE_PMD_IXGBE_MB_EVENT_PROCEED
    proceed with mbox request

RTE_PMD_IXGBE_MB_EVENT_MAX
    max value of this enum

Definition at line 653 of file rte_pmd_ixgbe.h.

Function Documentation

  int rte_pmd_ixgbe_ping_vf (uint16_t port, uint16_t vf)
Notify VF when PF link status changes.

Parameters
    port The port identifier of the Ethernet device.
    vf VF id.

Returns

    •   (0) if successful.

    •   (-ENODEV) if port invalid.

    •   (-EINVAL) if vf invalid.

  int rte_pmd_ixgbe_set_vf_mac_addr (uint16_t port, uint16_t vf, struct rte_ether_addr * mac_addr)
Set the VF MAC address.

Parameters
    port The port identifier of the Ethernet device.
    vf VF id.
    mac_addr VF MAC address.

Returns

    •   (0) if successful.

    •   (-ENODEV) if port invalid.

    •   (-EINVAL) if vf or mac_addr is invalid.

  int rte_pmd_ixgbe_set_vf_vlan_anti_spoof (uint16_t port, uint16_t vf, uint8_t on)
Enable/Disable VF VLAN anti spoofing.

Parameters
    port The port identifier of the Ethernet device.
    vf VF on which to set VLAN anti spoofing.
    on 1 - Enable VFs VLAN anti spoofing. 0 - Disable VFs VLAN anti spoofing.

Returns

    •   (0) if successful.

    •   (-ENODEV) if port invalid.

    •   (-EINVAL) if bad parameter.

  int rte_pmd_ixgbe_set_vf_mac_anti_spoof (uint16_t port, uint16_t vf, uint8_t on)
Enable/Disable VF MAC anti spoofing.

Parameters
    port The port identifier of the Ethernet device.
    vf VF on which to set MAC anti spoofing.
    on 1 - Enable VFs MAC anti spoofing. 0 - Disable VFs MAC anti spoofing.

Returns

    •   (0) if successful.

    •   (-ENODEV) if port invalid.

    •   (-EINVAL) if bad parameter.

  int rte_pmd_ixgbe_set_vf_vlan_insert (uint16_t port, uint16_t vf, uint16_t vlan_id)
Enable/Disable vf vlan insert

Parameters
    port The port identifier of the Ethernet device.
    vf ID specifying VF.
    vlan_id 0 - Disable VF's vlan insert. n - Enable; n is inserted as the vlan id.

Returns

    •   (0) if successful.

    •   (-ENODEV) if port invalid.

    •   (-EINVAL) if bad parameter.

  int rte_pmd_ixgbe_set_tx_loopback (uint16_t port, uint8_t on)
Enable/Disable tx loopback

Parameters
    port The port identifier of the Ethernet device.
    on 1 - Enable tx loopback. 0 - Disable tx loopback.

Returns

    •   (0) if successful.

    •   (-ENODEV) if port invalid.

    •   (-EINVAL) if bad parameter.

  int rte_pmd_ixgbe_set_all_queues_drop_en (uint16_t port, uint8_t on)
set all queues drop enable bit

Parameters
    port The port identifier of the Ethernet device.
    on 1 - set the queue drop enable bit for all pools. 0 - reset the queue drop enable bit for all pools.

Returns

    •   (0) if successful.

    •   (-ENODEV) if port invalid.

    •   (-EINVAL) if bad parameter.

  int rte_pmd_ixgbe_set_vf_split_drop_en (uint16_t port, uint16_t vf, uint8_t on)
set drop enable bit in the VF split rx control register

Parameters
    port The port identifier of the Ethernet device.
    vf ID specifying VF.
    on 1 - set the drop enable bit in the split rx control register. 0 - reset the drop enable bit in the split rx control register.

Returns

    •   (0) if successful.

    •   (-ENODEV) if port invalid.

    •   (-EINVAL) if bad parameter.

  int rte_pmd_ixgbe_set_vf_vlan_stripq (uint16_t port, uint16_t vf, uint8_t on)
Enable/Disable vf vlan strip for all queues in a pool

Parameters
    port The port identifier of the Ethernet device.
    vf ID specifying VF.
    on 1 - Enable VF's vlan strip on RX queues. 0 - Disable VF's vlan strip on RX queues.

Returns

    •   (0) if successful.

    •   (-ENOTSUP) if hardware doesn't support this feature.

    •   (-ENODEV) if port invalid.

    •   (-EINVAL) if bad parameter.

  int rte_pmd_ixgbe_macsec_enable (uint16_t port, uint8_t en, uint8_t rp)
Enable MACsec offload.

Parameters
    port The port identifier of the Ethernet device.
    en 1 - Enable encryption (encrypt and add integrity signature). 0 - Disable encryption (only add integrity signature).
    rp 1 - Enable replay protection. 0 - Disable replay protection.

Returns

    •   (0) if successful.

    •   (-ENODEV) if port invalid.

    •   (-ENOTSUP) if hardware doesn't support this feature.

  int rte_pmd_ixgbe_macsec_disable (uint16_t port)
Disable MACsec offload.

Parameters
    port The port identifier of the Ethernet device.

Returns

    •   (0) if successful.

    •   (-ENODEV) if port invalid.

    •   (-ENOTSUP) if hardware doesn't support this feature.

  int rte_pmd_ixgbe_macsec_config_txsc (uint16_t port, uint8_t * mac)
Configure Tx SC (Secure Connection).

Parameters
    port The port identifier of the Ethernet device.
    mac The MAC address on the local side.

Returns

    •   (0) if successful.

    •   (-ENODEV) if port invalid.

    •   (-ENOTSUP) if hardware doesn't support this feature.

  int rte_pmd_ixgbe_macsec_config_rxsc (uint16_t port, uint8_t * mac, uint16_t pi)
Configure Rx SC (Secure Connection).

Parameters
    port The port identifier of the Ethernet device.
    mac The MAC address on the remote side.
    pi The PI (port identifier) on the remote side.

Returns

    •   (0) if successful.

    •   (-ENODEV) if port invalid.

    •   (-ENOTSUP) if hardware doesn't support this feature.

  int rte_pmd_ixgbe_macsec_select_txsa (uint16_t port, uint8_t idx, uint8_t an, uint32_t pn, uint8_t * key)
Enable Tx SA (Secure Association).

Parameters
    port The port identifier of the Ethernet device.
    idx The SA to be enabled (0 or 1).
    an The association number on the local side.
    pn The packet number on the local side.
    key The key on the local side.

Returns

    •   (0) if successful.

    •   (-ENODEV) if port invalid.

    •   (-ENOTSUP) if hardware doesn't support this feature.

    •   (-EINVAL) if bad parameter.

  int rte_pmd_ixgbe_macsec_select_rxsa (uint16_t port, uint8_t idx, uint8_t an, uint32_t pn, uint8_t * key)
Enable Rx SA (Secure Association).

Parameters
    port The port identifier of the Ethernet device.
    idx The SA to be enabled (0 or 1)
    an The association number on the remote side.
    pn The packet number on the remote side.
    key The key on the remote side.

Returns

    •   (0) if successful.

    •   (-ENODEV) if port invalid.

    •   (-ENOTSUP) if hardware doesn't support this feature.

    •   (-EINVAL) if bad parameter.

  int rte_pmd_ixgbe_set_vf_rxmode (uint16_t port, uint16_t vf, uint16_t rx_mask, uint8_t on)
Set RX L2 Filtering mode of a VF of an Ethernet device.

Parameters
    port The port identifier of the Ethernet device.
    vf VF id.
    rx_mask The RX mode mask, which is one or more of accepting Untagged Packets, packets that match the PFUTA table, Broadcast and Multicast Promiscuous. RTE_ETH_VMDQ_ACCEPT_UNTAG, RTE_ETH_VMDQ_ACCEPT_HASH_UC, RTE_ETH_VMDQ_ACCEPT_BROADCAST and RTE_ETH_VMDQ_ACCEPT_MULTICAST will be used in rx_mode.
    on 1 - Enable a VF RX mode. 0 - Disable a VF RX mode.

Returns

    •   (0) if successful.

    •   (-ENOTSUP) if hardware doesn't support.

    •   (-ENODEV) if port_id invalid.

    •   (-EINVAL) if bad parameter.

  int rte_pmd_ixgbe_set_vf_rx (uint16_t port, uint16_t vf, uint8_t on)
Enable or disable a VF traffic receive of an Ethernet device.

Parameters
    port The port identifier of the Ethernet device.
    vf VF id.
    on 1 - Enable a VF traffic receive. 0 - Disable a VF traffic receive.

Returns

    •   (0) if successful.

    •   (-ENOTSUP) if hardware doesn't support.

    •   (-ENODEV) if port_id invalid.

    •   (-EINVAL) if bad parameter.

  int rte_pmd_ixgbe_set_vf_tx (uint16_t port, uint16_t vf, uint8_t on)
Enable or disable a VF traffic transmit of the Ethernet device.

Parameters
    port The port identifier of the Ethernet device.
    vf VF id.
    on 1 - Enable a VF traffic transmit. 0 - Disable a VF traffic transmit.

Returns

    •   (0) if successful.

    •   (-ENODEV) if port_id invalid.

    •   (-ENOTSUP) if hardware doesn't support.

    •   (-EINVAL) if bad parameter.

  int rte_pmd_ixgbe_set_vf_vlan_filter (uint16_t port, uint16_t vlan, uint64_t vf_mask, uint8_t vlan_on)
Enable/Disable hardware VF VLAN filtering by an Ethernet device of received VLAN packets tagged with a given VLAN Tag Identifier.

Parameters
    port The port identifier of the Ethernet device.
    vlan The VLAN Tag Identifier whose filtering must be enabled or disabled.
    vf_mask Bitmap listing which VFs participate in the VLAN filtering.
    vlan_on 1 - Enable VFs VLAN filtering. 0 - Disable VFs VLAN filtering.

Returns

    •   (0) if successful.

    •   (-ENOTSUP) if hardware doesn't support.

    •   (-ENODEV) if port_id invalid.

    •   (-EINVAL) if bad parameter.

  int rte_pmd_ixgbe_set_vf_rate_limit (uint16_t port, uint16_t vf, uint32_t tx_rate, uint64_t q_msk)
Set the rate limitation for a vf on an Ethernet device.

Parameters
    port The port identifier of the Ethernet device.
    vf VF id.
    tx_rate The tx rate allocated from the total link speed for this VF id.
    q_msk The queue mask which need to set the rate.

Returns

    •   (0) if successful.

    •   (-ENOTSUP) if hardware doesn't support this feature.

    •   (-ENODEV) if port_id invalid.

    •   (-EINVAL) if bad parameter.

  int rte_pmd_ixgbe_set_tc_bw_alloc (uint16_t port, uint8_t tc_num, uint8_t * bw_weight)
Set all the TCs' bandwidth weight.

The bw_weight means the percentage occupied by the TC. It can be taken as the relative min bandwidth setting.

Parameters
    port The port identifier of the Ethernet device.
    tc_num Number of TCs.
    bw_weight An array of relative bandwidth weight for all the TCs. The summary of the bw_weight should be 100.

Returns

    •   (0) if successful.

    •   (-ENODEV) if port invalid.

    •   (-EINVAL) if bad parameter.

    •   (-ENOTSUP) not supported by firmware.

  int rte_pmd_ixgbe_bypass_init (uint16_t port)
Initialize bypass logic. This function needs to be called before executing any other bypass API.

Parameters
    port The port identifier of the Ethernet device.

Returns

    •   (0) if successful.

    •   (-ENOTSUP) if hardware doesn't support.

    •   (-EINVAL) if bad parameter.

  int rte_pmd_ixgbe_bypass_state_show (uint16_t port, uint32_t * state)
Return bypass state.

Parameters
    port The port identifier of the Ethernet device.
    state The return bypass state.

    •   (1) Normal mode

    •   (2) Bypass mode

    •   (3) Isolate mode

Returns

    •   (0) if successful.

    •   (-ENOTSUP) if hardware doesn't support.

    •   (-EINVAL) if bad parameter.

  int rte_pmd_ixgbe_bypass_state_set (uint16_t port, uint32_t * new_state)
Set bypass state

Parameters
    port The port identifier of the Ethernet device.
    new_state The current bypass state.

    •   (1) Normal mode

    •   (2) Bypass mode

    •   (3) Isolate mode

Returns

    •   (0) if successful.

    •   (-ENOTSUP) if hardware doesn't support.

    •   (-EINVAL) if bad parameter.

  int rte_pmd_ixgbe_bypass_event_show (uint16_t port, uint32_t event, uint32_t * state)
Return bypass state when given event occurs.

Parameters
    port The port identifier of the Ethernet device.
    event The bypass event

    •   (1) Main power on (power button is pushed)

    •   (2) Auxiliary power on (power supply is being plugged)

    •   (3) Main power off (system shutdown and power supply is left plugged in)

    •   (4) Auxiliary power off (power supply is being unplugged)

    •   (5) Display or set the watchdog timer

    state The bypass state when given event occurred.

    •   (1) Normal mode

    •   (2) Bypass mode

    •   (3) Isolate mode

Returns

    •   (0) if successful.

    •   (-ENOTSUP) if hardware doesn't support.

    •   (-EINVAL) if bad parameter.

  int rte_pmd_ixgbe_bypass_event_store (uint16_t port, uint32_t event, uint32_t state)
Set bypass state when given event occurs.

Parameters
    port The port identifier of the Ethernet device.
    event The bypass event

    •   (1) Main power on (power button is pushed)

    •   (2) Auxiliary power on (power supply is being plugged)

    •   (3) Main power off (system shutdown and power supply is left plugged in)

    •   (4) Auxiliary power off (power supply is being unplugged)

    •   (5) Display or set the watchdog timer

    state The assigned state when given event occurs.

    •   (1) Normal mode

    •   (2) Bypass mode

    •   (3) Isolate mode

Returns

    •   (0) if successful.

    •   (-ENOTSUP) if hardware doesn't support.

    •   (-EINVAL) if bad parameter.

  int rte_pmd_ixgbe_bypass_wd_timeout_store (uint16_t port, uint32_t timeout)
Set bypass watchdog timeout count.

Parameters
    port The port identifier of the Ethernet device.
    timeout The timeout to be set.

    •   (0) 0 seconds (timer is off)

    •   (1) 1.5 seconds

    •   (2) 2 seconds

    •   (3) 3 seconds

    •   (4) 4 seconds

    •   (5) 8 seconds

    •   (6) 16 seconds

    •   (7) 32 seconds

Returns

    •   (0) if successful.

    •   (-ENOTSUP) if hardware doesn't support.

    •   (-EINVAL) if bad parameter.

  int rte_pmd_ixgbe_bypass_ver_show (uint16_t port, uint32_t * ver)
Get bypass firmware version.

Parameters
    port The port identifier of the Ethernet device.
    ver The firmware version

Returns

    •   (0) if successful.

    •   (-ENOTSUP) if hardware doesn't support.

    •   (-EINVAL) if bad parameter.

  int rte_pmd_ixgbe_bypass_wd_timeout_show (uint16_t port, uint32_t * wd_timeout)
Return bypass watchdog timeout in seconds

Parameters
    port The port identifier of the Ethernet device.
    wd_timeout The return watchdog timeout. "0" represents timer expired

    •   (0) 0 seconds (timer is off)

    •   (1) 1.5 seconds

    •   (2) 2 seconds

    •   (3) 3 seconds

    •   (4) 4 seconds

    •   (5) 8 seconds

    •   (6) 16 seconds

    •   (7) 32 seconds

Returns

    •   (0) if successful.

    •   (-ENOTSUP) if hardware doesn't support.

    •   (-EINVAL) if bad parameter.

  int rte_pmd_ixgbe_bypass_wd_reset (uint16_t port)
Reset bypass watchdog timer

Parameters
    port The port identifier of the Ethernet device.

Returns

    •   (0) if successful.

    •   (-ENOTSUP) if hardware doesn't support.

    •   (-EINVAL) if bad parameter.

  int rte_pmd_ixgbe_mdio_lock (uint16_t port)
Acquire swfw semaphore lock for MDIO access

Parameters
    port The port identifier of the Ethernet device.

Returns

    •   (0) if successful.

    •   (-ENOTSUP) if hardware doesn't support.

    •   (-ENODEV) if port invalid.

    •   (IXGBE_ERR_SWFW_SYNC) If sw/fw semaphore acquisition failed

  int rte_pmd_ixgbe_mdio_unlock (uint16_t port)
Release swfw semaphore lock used for MDIO access

Parameters
    port The port identifier of the Ethernet device.

Returns

    •   (0) if successful.

    •   (-ENOTSUP) if hardware doesn't support.

    •   (-ENODEV) if port invalid.

  int rte_pmd_ixgbe_mdio_unlocked_read (uint16_t port, uint32_t reg_addr, uint32_t dev_type, uint16_t * phy_data)
Read PHY register using MDIO without MDIO lock The lock must be taken separately before calling this API

Parameters
    port The port identifier of the Ethernet device.
    reg_addr 32 bit PHY Register
    dev_type Used to define device base address
    phy_data Pointer for reading PHY register data

Returns

    •   (0) if successful.

    •   (-ENOTSUP) if hardware doesn't support.

    •   (-ENODEV) if port invalid.

    •   (IXGBE_ERR_PHY) If PHY read command failed

  int rte_pmd_ixgbe_mdio_unlocked_write (uint16_t port, uint32_t reg_addr, uint32_t dev_type, uint16_t phy_data)
Write data to PHY register using without MDIO lock The lock must be taken separately before calling this API

Parameters
    port The port identifier of the Ethernet device.
    reg_addr 32 bit PHY Register
    dev_type Used to define device base address
    phy_data Data to write to PHY register

Returns

    •   (0) if successful.

    •   (-ENOTSUP) if hardware doesn't support.

    •   (-ENODEV) if port invalid.

    •   (IXGBE_ERR_PHY) If PHY read command failed

  int rte_pmd_ixgbe_upd_fctrl_sbp (uint16_t port, int enable)

Parameters
    port The port identifier of the Ethernet device.
    enable 0 to disable and nonzero to enable 'SBP' bit in FCTRL register to receive all packets

Returns

    •   (0) if successful.

    •   (-ENODEV) if port invalid.

    •   (-ENOTSUP) if hardware doesn't support this feature.

  __rte_experimental int rte_pmd_ixgbe_get_fdir_info (uint16_t port, struct rte_eth_fdir_info * fdir_info)
Get port fdir info

Parameters
    port The port identifier of the Ethernet device.
    fdir_info The fdir info of the port

Returns

    •   (0) if successful.

    •   (-ENODEV) if port invalid.

    •   (-ENOTSUP) if operation not supported.

  __rte_experimental int rte_pmd_ixgbe_get_fdir_stats (uint16_t port, struct rte_eth_fdir_stats * fdir_stats)
Get port fdir status

Parameters
    port The port identifier of the Ethernet device.
    fdir_stats The fdir status of the port

Returns

    •   (0) if successful.

    •   (-ENODEV) if port invalid.

    •   (-ENOTSUP) if operation not supported.

Author

Generated automatically by Doxygen for DPDK from the source code.